app.directive('scrollToItem', function() {
    return {                                                                                 
        restrict: 'A',                                                                       
        scope: {                                                                             
            scrollto: "@"                                                                    
        },                                                                                   
        link: function(scope, $element) {                                                   

            $element.on('click', function() {                                                    
                $('html,body').animate({scrollTop: $(scope.scrollto).offset().top }, "slow");
            });                                                                              
        }                                                                                    
    };
});

app.directive('dataAos', function () {
    return {
        restrict: 'A',
        controller: function(){
            AOS.refresh();
        }
    };
});

app.directive('parallaxWindow', function () {
    return {
        restrict: 'C',
        controller: function(){
            setTimeout(function(){
                $('.parallax-window').parallax();
            }, 300);
        }
    };
});

app.directive('capitalize', function() {
    return {
      require: 'ngModel',
      link: function(scope, element, attrs, modelCtrl) {
        var capitalize = function(inputValue) {
          if (isBlank(inputValue)){
            inputValue = '';
          }
          var capitalized = inputValue.toUpperCase();
          if (capitalized !== inputValue) {
            // see where the cursor is before the update so that we can set it back
            var selection = element[0].selectionStart;
            modelCtrl.$setViewValue(capitalized);
            modelCtrl.$render();
            // set back the cursor after rendering
            element[0].selectionStart = selection;
            element[0].selectionEnd = selection;
          }
          return capitalized;
        };
        modelCtrl.$parsers.push(capitalize);
        capitalize(scope[attrs.ngModel]); // capitalize initial value
      }
    };
});