app.directive('ngReferenceStatus', function ($timeout, $translate) {
    return {
        restrict: 'E', //E = element, A = attribute, C = class, M = comment,
        templateUrl: 'templates/refrence-status.html',
        controller: function($scope, referenceService) {
            $scope.reference = null;
            $scope.amount = null;
            $scope.payment = null;
            $scope.merchant = null;
            $scope.store = null;
            $scope.customer= null;
            $scope.procesing = false;
            $scope.captcha = null;
            
            $scope.initRecaptcha= function() {
                $timeout($scope.loadRecaptcha, 1000);
			};

            $scope.loadRecaptcha = function() {
                grecaptcha.render('g-recaptcha', {
                    'sitekey' : '6LfNrkgUAAAAAPQ6mGNhsDEIkisV38yjqnD4SLvF',
                    'callback' : $scope.setCaptcha,
                    'expired-callback': $scope.cleanCaptcha,
                    'error-callback': $scope.cleanCaptcha
                });
             };
            
            $scope.setCaptcha = function(response) {
                $scope.captcha = response;
                $scope.$apply();
             };
            
            $scope.cleanCaptcha = function() {
                $scope.captcha = null;
                $scope.$apply();
             };
            
            $scope.getPaymentStatusClass = function() {
                if (isNull($scope.payment)) {
                    return 'bg-warning';
                }
                if (eq($scope.payment.status, 'completed')){
                    return 'bg-success';
                } else if (eq($scope.payment.status, 'in_progress')){
                    return 'bg-info';
                } else if (eq($scope.payment.status, 'cancelled')){
                    return 'bg-secondary';
                } else {
                    return 'bg-warning';
                }
            };
            
            $scope.getReferenceInfo = function() {
                $scope.procesing = true;
                referenceService.getReferenceInfo($scope.reference, $scope.amount, $scope.captcha,
                    function(response) {
                        if (isNull(response) || 
                            isNull(response.data) || 
                            isNull(response.data.data) || 
                            isNull(response.data.data.payment)) {
                            toastr.warning($translate.instant('lbl.response.paymentNotFound'), '', 5000);
                            return;
                        }
                        response = response.data.data;
                        var payment = response.payment;
                        if (isNotNull(payment.creation_date)) {
                            payment.creation_date = new Date(payment.creation_date);
                        }
                        if (isNotNull(payment.operation_date)) {
                            payment.operation_date = new Date(payment.operation_date);
                        }
                        if (isNotNull(payment.due_date)) {
                            payment.due_date = new Date(payment.due_date);
                        }
                        $scope.payment = payment;
                        $scope.merchant = response.merchant;
                        $scope.customer= response.customer;
                        $scope.store = response.store;
                        $("#modalReferenceStatus").modal('show');
                    }, null, function() {
                        $scope.procesing = false;
                        $scope.captcha = null;
                        grecaptcha.reset();
                    });
            };
        }
    };
});
