app.service('requestService', function($http, $translate) {
	
	var successCall = function(response, callback, errorCallback) {
		if (isNotNull(response) && 
				isNotNull(response.data) && 
				response.data.status === 'error') {
			errorCall(response, errorCallback);
			return;
		}
		if (isNotNull(callback)) {
			callback(response);
		}
	};
	
	var finalCall = function(callback) {
		if (isNotNull(callback)) {
			callback();
		}
	};
	
	var errorCall = function(response, callback){
		if (isNull(response) || isNull(response.data)){
			toastr.error($translate.instant('lbl.response.error'));
			callback(response);
			return;
		}
		var data = response.data;
		if (isNotEmpty(data.message)) {
			toastr.error($translate.instant(data.message), "Error");
		} else {
			toastr.error($translate.instant('lbl.response.error'));
		}
		if (isNotNull(callback)) {
			callback(response);
		}
	};
	
	var connectionErrorCall = function(response){
		toastr.error($translate.instant('lbl.response.error'));
		if (isNull(response) || isNull(response.data)){	
			return;
		}
	};
	
	this.call = function(method, url, data, onOk, onError, onFinally) {
		if (isNull(data)) {
			data = '';
		}
		var params = null;
		if (eq("GET", method)) {
			params = data;
			data = null;
		}
		$http({
			  method: method,
			  url: url,
			  data: data,
			  params: params,
			  headers: {
			        "Content-Type": "application/json"
			  }
			}).then(function successCallback(response) {
				successCall(response, onOk, onError);
			  }, function errorCallback(response) {
				connectionErrorCall(response);
			  }).finally(
			function fin(){
				finalCall(onFinally);
			});
	};
    
});